// ConnectionEx.java
// socket connection extension class.

package JP.gr.java_conf.tech.net;

import java.io.*;

/**
	Socketڑ̊gNX

	@version	1.01	09/17/1999
	@author		Takahiro Shigemoto
*/
public class ConnectionEx extends Connection
{
	BufferedReader	reader;		// eLXgMpXg[
	BufferedWriter	writer;		// eLXgMpXg[

	/**
		zXgƃ|[gw肵ĐڑB
	*/
	public ConnectionEx(String host_name, int port)
	{
		super(host_name, port);

		// I/OXg[̍\z
		reader = new BufferedReader(new InputStreamReader(input));
		writer = new BufferedWriter(new OutputStreamWriter(output));
	}

	/**
		𑗐M(sR[h)B
		@param	str	M镶
		@return	Mɐ0As-1ԂB
	*/
	public int send(String str)
	{
		try
		{
			writer.write(str);
			writer.flush();

			return(0);
		}
		catch(IOException io_ex)
		{
			System.err.println(io_ex);
			return(-1);
		}
	}

	/**
		𑗐M(sR[hL)B
		@param	str	M镶
		@return	Mɐ0As-1ԂB
	*/
	public int sendLine(String str)
	{
		return(send(str + "\r\n"));
	}

	/**
		̒w肵đMB
		@param	str	M镶
		@param	len	M钷
		@return	Mɐ0As-1ԂB
	*/
	public int sendLine(String str, int len)
	{
		return(sendLine(str.substring(0, len)));
	}

	/**
		oCi𑗐M(sR[h)B
		@param	binary	MByte
		@return	Mɐ0As-1ԂB
	*/
	public int send(byte binary[])
	{
		return(send(binary, 0, binary.length));
	}

	/**
		oCi𑗐M(sR[hL)B
		@param	binary	MByte
		@return	Mɐ0As-1ԂB
	*/
	public int sendLine(byte binary[])
	{
		try
		{
			if(send(binary) != 0)
				return(-1);
			writer.write("\r\n");
			writer.flush();

			return(0);
		}
		catch(IOException io_ex)
		{
			System.err.println(io_ex);
			return(-1);
		}
	}

	/**
		s̕MB
		@param	buf	Mpobt@
		@return	Mɐ0As-1ԂB
	*/
	public int recvLine(StringBuffer buf)
	{
		try
		{
			buf.append(reader.readLine());

			return(0);
		}
		catch(InterruptedIOException ii_ex)
		{
			// ubLOA^CAEgԂo߂ꍇ
			return(-1);
		}
		catch(IOException io_ex)
		{
			System.err.println(io_ex);
			return(-1);
		}
	}
}