// Session.java
// Base class for Session layer

package JP.gr.java_conf.tech.net;

/**
	ZbVw{NX

	@version	1.01	09/17/1999
	@author		Takahiro Shigemoto
*/
public class Session extends ConnectionEx
{
	private final boolean b_debug = true;

	/**
		zXgƃ|[gw肵ĐڑB
	*/
	public Session(String server_name, int port)
	{
		super(server_name, port);
	}

	/**
		T[oֈsM
		@param	msg	M镶
	*/
	public void sendData(String msg)
	{
		if(b_debug)
			System.out.println("Send: " + msg);

		sendLine(msg);
	}

	/**
		T[os󂯎
		@return	T[o󂯎
	*/
	public String recvData()
	{
		StringBuffer buf = new StringBuffer();
		if(recvLine(buf) == -1)
			return(null);

		if(b_debug)
			System.out.println("Recv: " + buf.toString());

		return(buf.toString());
	}

	/**
		T[õ^[bZ[WA^[R[hoB
		@param	server_message	T[õbZ[W
		@return	ꂽ3̃T[o^[R[h
	*/
	public int getReturnCodeFromMessage(String server_message)
	{
		return(Integer.parseInt(server_message.substring(0,3)));
	}

	/**
		T[õ^[R[hƊ҂R[hv邩ǂ𒲂ׂB
		@param	server_message	T[õbZ[W
		@param	expect_code		҂R[hio[(3)
		@return	T[õ^[R[hƈvĂtrueAłȂfalseԂ
	*/
	public boolean checkReturnCode(String server_message, int expect_code)
	{
		int recv_code = getReturnCodeFromMessage(server_message);

		if(recv_code == expect_code)
			return(true);
		else
			return(false);
	}

	/**
		T[õ^[R[h(擾)Ɗ҂R[hv邩ǂ𒲂ׂB
		@param	expect_code		҂R[hio[(3)
		@return	T[õ^[R[hƈvĂtrueAłȂfalseԂ
	*/
	public boolean checkReturnCode(int expect_code)
	{
		String server_message = recvData();
		return(checkReturnCode(server_message, expect_code));
	}
}